package org.vendor.console;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.List;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.console.ConsolePlugin;
import org.eclipse.ui.console.IConsole;
import org.eclipse.ui.console.IConsoleManager;
import org.eclipse.ui.internal.console.ConsoleManager;
import org.eclipse.ui.internal.console.ConsoleView;

public class ConsoleHelper {
  public static List<ConsoleView> getConsoleViews() {
    List<ConsoleView> consoleViews = new ArrayList<>();
    try {
      IConsoleManager consoleManager = ConsolePlugin.getDefault().getConsoleManager();
      Class<ConsoleManager> clazz = ConsoleManager.class;
      Field declaredField = clazz.getDeclaredField("fConsoleViews");
      declaredField.setAccessible(true);
      List consoleViewsObj = (List)declaredField.get(consoleManager);
      for (Object object : consoleViewsObj) {
        if (object instanceof ConsoleView)
          consoleViews.add((ConsoleView)object); 
      } 
    } catch (Throwable throwable) {}
    return consoleViews;
  }
  
  public static boolean removeConsoles(List<IConsole> toRemove) {
    ConsolePlugin consolePlugin = ConsolePlugin.getDefault();
    if (consolePlugin == null)
      return false; 
    IConsoleManager consoleManager = consolePlugin.getConsoleManager();
    if (consoleManager == null)
      return false; 
    IConsole[] current = consoleManager.getConsoles();
    List<IConsole> toremovelist = new ArrayList<>();
    if (current != null) {
      for (IConsole console : current) {
        if (toRemove.contains(console))
          toremovelist.add(console); 
      } 
      consoleManager.removeConsoles(toremovelist
          .<IConsole>toArray(new IConsole[toremovelist.size()]));
    } 
    return true;
  }
  
  public static void display(IConsole console) {
    IConsoleManager consoleManager = ConsolePlugin.getDefault().getConsoleManager();
    try {
      consoleManager.showConsoleView(console);
    } catch (Exception e) {
      try {
        consoleManager.showConsoleView(console);
      } catch (Exception e1) {
        e1.printStackTrace();
      } 
    } 
  }
  
  public static void display2(IConsole console) {
    try {
      IConsoleManager consoleManager = ConsolePlugin.getDefault().getConsoleManager();
      Class<ConsoleManager> clazz = ConsoleManager.class;
      Field declaredField = clazz.getDeclaredField("fConsoleViews");
      declaredField.setAccessible(true);
      List consoleViews = (List)declaredField.get(consoleManager);
      for (int i = 0; i < consoleViews.size(); i++) {
        Object object = consoleViews.get(i);
        Display.getDefault().asyncExec((Runnable)new Object(object, console));
      } 
    } catch (Throwable throwable) {}
  }
  
  public static void addConsole(IConsole console) {
    List<ConsoleView> consoleViews = getConsoleViews();
    boolean[] caches = new boolean[consoleViews.size()];
    for (int i = 0; i < caches.length; i++) {
      ConsoleView consoleView = consoleViews.get(i);
      caches[i] = consoleView.isPinned();
      if (!caches[i])
        consoleView.setPinned(true); 
    } 
    IConsoleManager consoleManager = ConsolePlugin.getDefault().getConsoleManager();
    consoleManager.addConsoles(new IConsole[] { console });
    try {
      Thread.sleep(500L);
    } catch (InterruptedException e) {
      e.printStackTrace();
    } 
    for (int j = 0; j < caches.length; j++) {
      ConsoleView consoleView = consoleViews.get(j);
      consoleView.setPinned(caches[j]);
    } 
  }
  
  public static IConsole addAndShowConsole(IConsole console) {
    IConsoleManager consoleManager = ConsolePlugin.getDefault().getConsoleManager();
    consoleManager.addConsoles(new IConsole[] { console });
    return console;
  }
}
